/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasFederatedSettingsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.10.0/docs/data-sources/federated_settings#org_id DataMongodbatlasFederatedSettings#org_id}
    */
    readonly orgId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.10.0/docs/data-sources/federated_settings mongodbatlas_federated_settings}
*/
export declare class DataMongodbatlasFederatedSettings extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_federated_settings";
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.10.0/docs/data-sources/federated_settings mongodbatlas_federated_settings} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasFederatedSettingsConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasFederatedSettingsConfig);
    get federatedDomains(): string[];
    get hasRoleMappings(): cdktf.IResolvable;
    get id(): string;
    get identityProviderId(): string;
    get identityProviderStatus(): string;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    get orgIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
